/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.test;

import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

/**
 *
 * @author Adam
 */
public class TestListener extends TimerTask implements ServletContextListener{

    static Logger log = Logger.getLogger(TestListener.class.getName());

    @EJB(name="TestSSBRemote")
    private TestSSBRemote remote;

    private Timer timer = new Timer();

    @Override
    public void run() {
        log.info("TestListener.run()...calling ejb method");                        
        //Issue #8590 -- This call will take longer and longer each time
        //until it takes so long that the EJB times out
        //you may have to let it run for a few hours
        remote.testCall();
        log.info("EJB method call complete");
    }

    public void contextInitialized(ServletContextEvent arg0) {
        log.info("TestListener.contextInitialized");

        //Issue #8589...injection of remote fails at this stage...so
        //if I need to call it during initialization of any listener or filter
        //it's not an option
        log.info("Remote is " + remote);


        //set up ten minute repeats for Issue #8590
        log.info("Scheduling timer");
        timer.schedule(this, 0, 10*60*1000);
    }

    public void contextDestroyed(ServletContextEvent arg0) {
        
    }

}
